//+------------------------------------------------------------------+
//|                       double dynamic zone williams percent range |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 10
#property indicator_color1  clrRed
#property indicator_color2  clrDodgerBlue
#property indicator_color3  clrRed
#property indicator_color4  clrDodgerBlue
#property indicator_color5  clrGold
#property indicator_color6  clrSilver
#property indicator_color7  clrDodgerBlue
#property indicator_color8  clrDodgerBlue
#property indicator_color9  clrSandyBrown
#property indicator_color10 clrSandyBrown
#property indicator_width3  1
#property indicator_width4  1
#property indicator_width6  3
#property indicator_width7  3
#property indicator_width8  3
#property indicator_width9  3
#property indicator_width10 3
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_style5  STYLE_DASH
#property strict


//
//
//
//
//

#import "dynamicZone.dll"
   double dzBuy(double& sourceArray[],double initValue, int lookBack, int bars, int i);
   double dzSell(double& sourceArray[],double initValue, int lookBack, int bars, int i);
#import

//
//
//
//
//

enum enColorChangeOn
{
   chg_onSlope, // Color change on slope change
   chg_onMiddl, // Color change on middle levels cross
   chg_onInner, // Color change on inner levels cross
   chg_onOuter  // Color change on outer levels cross
};
extern ENUM_TIMEFRAMES TimeFrame               = PERIOD_CURRENT; // Time frame to use
extern int             HLR_Range               = 50;             // HLR range
extern int             Length                  = 25;             // OMA period
extern double          Speed                   = 8;              // OMA speed
extern bool            Adaptive                = true;           // OMA should be adaptive?
extern int             DzLookBackBars          = 70;             // Dynamic zones lookback bars
extern double          DzStartBuyProbability1  = 0.20;           // Dynamic zones buy probability 1
extern double          DzStartSellProbability1 = 0.20;           // Dynamic zones sell probability 2
extern double          DzStartBuyProbability2  = 0.06;           // Dynamic zones buy probability 2
extern double          DzStartSellProbability2 = 0.06;           // Dynamic zones sell probability 2
extern enColorChangeOn ColorChangeOn           = chg_onSlope;    // Change colors on :
extern bool            alertsOn                = false;          // Turn alert on?
extern bool            alertsOnCurrent         = true;           // Alert on current (still opened) bar?
extern bool            alertsMessage           = true;           // Alert should show popup message?
extern bool            alertsPush              = false;          // Alert should send push notification??
extern bool            alertsEmail             = false;          // Alert should send an email
extern bool            alertsSound             = false;          // Alert should play a sound?
extern string          soundfile               = "alert2.wav";   // Alert sound file
extern bool            AutomaticColors         = false;          // Assign automatic colors?
extern bool            Interpolate             = true;           // Interpolate in multi time frame mode?

//
//
//
//
//

double HLR_Buffer[],bufupa[],bufupb[],bufdna[],bufdnb[],state[];
double bli1[];
double sli1[];
double bli2[];
double sli2[];
double slic[];

string IndicatorFileName;
bool   returninBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(11);
   SetIndexBuffer(0,bli1); SetIndexLabel(0,"level "+(string)DzStartBuyProbability1);
   SetIndexBuffer(1,sli1);
   SetIndexBuffer(2,bli2);
   SetIndexBuffer(3,sli2);
   SetIndexBuffer(4,slic);
   SetIndexBuffer(5,HLR_Buffer);
   SetIndexBuffer(6,bufupa);
   SetIndexBuffer(7,bufupb);
   SetIndexBuffer(8,bufdna);
   SetIndexBuffer(9,bufdnb);
   SetIndexBuffer(10,state);
   
   Length = MathMax(Length,   1);
   Speed  = MathMax(Speed ,-1.5);

   //
   //
   //
   //
   //
   
         IndicatorFileName = WindowExpertName();
         returninBars      = (TimeFrame==-99);
         TimeFrame         = MathMax(TimeFrame,_Period);
   string shortName = "Dynamic zone Range_osc on oma "+timeFrameToString(TimeFrame)+" ("+(string)HLR_Range+")";
   IndicatorShortName(shortName);
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------


int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returninBars) { bli1[0] = limit+1; return(0); }
         if (AutomaticColors)
         {
            SetIndexStyle(0,EMPTY,EMPTY,EMPTY,(color)ChartGetInteger(0,CHART_COLOR_CANDLE_BEAR));
            SetIndexStyle(2,EMPTY,EMPTY,EMPTY,(color)ChartGetInteger(0,CHART_COLOR_CANDLE_BEAR));
            SetIndexStyle(1,EMPTY,EMPTY,EMPTY,(color)ChartGetInteger(0,CHART_COLOR_CANDLE_BULL));
            SetIndexStyle(3,EMPTY,EMPTY,EMPTY,(color)ChartGetInteger(0,CHART_COLOR_CANDLE_BULL));
            SetIndexStyle(4,EMPTY,EMPTY,EMPTY,(color)ChartGetInteger(0,CHART_COLOR_GRID));
            SetIndexStyle(6,EMPTY,EMPTY,EMPTY,(color)ChartGetInteger(0,CHART_COLOR_CANDLE_BULL));
            SetIndexStyle(7,EMPTY,EMPTY,EMPTY,(color)ChartGetInteger(0,CHART_COLOR_CANDLE_BULL));
            SetIndexStyle(8,EMPTY,EMPTY,EMPTY,(color)ChartGetInteger(0,CHART_COLOR_CANDLE_BEAR));
            SetIndexStyle(9,EMPTY,EMPTY,EMPTY,(color)ChartGetInteger(0,CHART_COLOR_CANDLE_BEAR));
         }      
         
   //
   //
   //
   //
   //         
   
   if (TimeFrame==_Period)
   {  
      if (state[limit]==-1) CleanPoint(limit,bufdna,bufdnb);
      if (state[limit]== 1) CleanPoint(limit,bufupa,bufupb);
      for(int i=limit; i>=0; i--)
      {
         double hhv  = iOma(High[iHighest(NULL, 0, MODE_HIGH, HLR_Range, i)],Length,Speed,Adaptive,i,0);
         double llv  = iOma(Low[iLowest(NULL, 0,   MODE_LOW,  HLR_Range, i)],Length,Speed,Adaptive,i,1);
         double m_pr = iOma((High[i] + Low[i]) / 2.0,                        Length,Speed,Adaptive,i,2);
         
         HLR_Buffer[i]   = 100.0 * (m_pr - llv) / (hhv - llv); 
               bli1[i]   = dzBuy (HLR_Buffer, DzStartBuyProbability1,  DzLookBackBars, Bars, i);
               sli1[i]   = dzSell(HLR_Buffer, DzStartSellProbability1, DzLookBackBars, Bars, i);
               bli2[i]   = dzBuy (HLR_Buffer, DzStartBuyProbability2,  DzLookBackBars, Bars, i);
               sli2[i]   = dzSell(HLR_Buffer, DzStartSellProbability2, DzLookBackBars, Bars, i);
               slic[i]   = dzSell(HLR_Buffer, 0.5                    , DzLookBackBars, Bars, i);
               bufupa[i] = EMPTY_VALUE;
               bufupb[i] = EMPTY_VALUE;
               bufdna[i] = EMPTY_VALUE;
               bufdnb[i] = EMPTY_VALUE;
               state[i]  = 0;
               switch (ColorChangeOn)
               {
                  case chg_onSlope: 
                     if (i<Bars-1)
                     {
                        if (HLR_Buffer[i]<HLR_Buffer[i+1]) state[i] =-1;
                        if (HLR_Buffer[i]>HLR_Buffer[i+1]) state[i] = 1;
                     }
                     break;
                  case chg_onMiddl: 
                        if (HLR_Buffer[i]<slic[i]) state[i] =-1;
                        if (HLR_Buffer[i]>slic[i]) state[i] = 1;
                     break;
                  case chg_onInner: 
                        if (HLR_Buffer[i]<bli1[i]) state[i] =-1;
                        if (HLR_Buffer[i]>sli1[i]) state[i] = 1;
                     break;
                  case chg_onOuter: 
                        if (HLR_Buffer[i]<bli2[i]) state[i] =-1;
                        if (HLR_Buffer[i]>sli2[i]) state[i] = 1;
                     break;
               }
               if (state[i] ==  1) PlotPoint(i,bufupa,bufupb,HLR_Buffer);
               if (state[i] == -1) PlotPoint(i,bufdna,bufdnb,HLR_Buffer);
         }
         manageAlerts();
         return(0);
      }

   //
   //
   //
   //
   //
   
   limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,IndicatorFileName,-99,0,0)*TimeFrame/Period()));
   if (state[limit]==-1) CleanPoint(limit,bufdna,bufdnb);
   if (state[limit]== 1) CleanPoint(limit,bufupa,bufupb);
   for(int i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
      HLR_Buffer[i] = iCustom(NULL,TimeFrame,IndicatorFileName,PERIOD_CURRENT,HLR_Range,Length,Speed,Adaptive,DzLookBackBars,DzStartBuyProbability1,DzStartSellProbability1,DzStartBuyProbability2,DzStartSellProbability2,ColorChangeOn,alertsOn,alertsOnCurrent,alertsMessage,alertsPush,alertsEmail,alertsSound,soundfile,5,y);
      bli1[i]       = iCustom(NULL,TimeFrame,IndicatorFileName,PERIOD_CURRENT,HLR_Range,Length,Speed,Adaptive,DzLookBackBars,DzStartBuyProbability1,DzStartSellProbability1,DzStartBuyProbability2,DzStartSellProbability2,ColorChangeOn,alertsOn,alertsOnCurrent,alertsMessage,alertsPush,alertsEmail,alertsSound,soundfile,0,y);
      sli1[i]       = iCustom(NULL,TimeFrame,IndicatorFileName,PERIOD_CURRENT,HLR_Range,Length,Speed,Adaptive,DzLookBackBars,DzStartBuyProbability1,DzStartSellProbability1,DzStartBuyProbability2,DzStartSellProbability2,ColorChangeOn,alertsOn,alertsOnCurrent,alertsMessage,alertsPush,alertsEmail,alertsSound,soundfile,1,y);
      bli2[i]       = iCustom(NULL,TimeFrame,IndicatorFileName,PERIOD_CURRENT,HLR_Range,Length,Speed,Adaptive,DzLookBackBars,DzStartBuyProbability1,DzStartSellProbability1,DzStartBuyProbability2,DzStartSellProbability2,ColorChangeOn,alertsOn,alertsOnCurrent,alertsMessage,alertsPush,alertsEmail,alertsSound,soundfile,2,y);
      sli2[i]       = iCustom(NULL,TimeFrame,IndicatorFileName,PERIOD_CURRENT,HLR_Range,Length,Speed,Adaptive,DzLookBackBars,DzStartBuyProbability1,DzStartSellProbability1,DzStartBuyProbability2,DzStartSellProbability2,ColorChangeOn,alertsOn,alertsOnCurrent,alertsMessage,alertsPush,alertsEmail,alertsSound,soundfile,3,y);
      slic[i]       = iCustom(NULL,TimeFrame,IndicatorFileName,PERIOD_CURRENT,HLR_Range,Length,Speed,Adaptive,DzLookBackBars,DzStartBuyProbability1,DzStartSellProbability1,DzStartBuyProbability2,DzStartSellProbability2,ColorChangeOn,alertsOn,alertsOnCurrent,alertsMessage,alertsPush,alertsEmail,alertsSound,soundfile,4,y);
      state[i]      = iCustom(NULL,TimeFrame,IndicatorFileName,PERIOD_CURRENT,HLR_Range,Length,Speed,Adaptive,DzLookBackBars,DzStartBuyProbability1,DzStartSellProbability1,DzStartBuyProbability2,DzStartSellProbability2,ColorChangeOn,alertsOn,alertsOnCurrent,alertsMessage,alertsPush,alertsEmail,alertsSound,soundfile,10,y);
      bufupa[i]     = EMPTY_VALUE;
      bufupb[i]     = EMPTY_VALUE;
      bufdna[i]     = EMPTY_VALUE;
      bufdnb[i]     = EMPTY_VALUE;
      
      if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;

         //
         //
         //
         //
         //

         int n,j; datetime time = iTime(NULL,TimeFrame,y);
              for(n = 1; (i+n)<Bars && Time[i+n] >= time; n++) continue;	
              for(j = 1; j<n && (i+n)<Bars && (i+j)<Bars; j++)
              {
                  HLR_Buffer[i+j] = HLR_Buffer[i] + (HLR_Buffer[i+n] - HLR_Buffer[i])*j/n;
                  bli1[i+j]       = bli1[i]       + (bli1[i+n]       - bli1[i]      )*j/n;
                  bli2[i+j]       = bli2[i]       + (bli2[i+n]       - bli2[i]      )*j/n;
                  sli1[i+j]       = sli1[i]       + (sli1[i+n]       - sli1[i]      )*j/n;
                  sli2[i+j]       = sli2[i]       + (sli2[i+n]       - sli2[i]      )*j/n;
                  slic[i+j]       = slic[i]       + (slic[i+n]       - slic[i]      )*j/n;
               }
   }      
   for(int i=limit; i>=0; i--)
   {
      if (state[i] ==  1) PlotPoint(i,bufupa,bufupb,HLR_Buffer);
      if (state[i] == -1) PlotPoint(i,bufdna,bufdnb,HLR_Buffer);
   }
   return(0);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

#define omaInstances 3
double workOma[][omaInstances*7];
#define F01 0
#define F02 1
#define F03 2
#define F04 3
#define F05 4
#define F06 5
#define prc 6

//
//
//
//
//

double iOma(double price, double averagePeriod, double constant, bool adaptive, int r, int instanceNo=0)
{
   if (averagePeriod <=1) return(price);
   if (ArrayRange(workOma,0) != Bars) ArrayResize(workOma,Bars); r=Bars-r-1; instanceNo *=7;
   if (r<=1) 
   {
      for (int i=0; i<6; i++) workOma[r][i  +instanceNo] = 0;
                              workOma[r][prc+instanceNo] = price;
                              return(price);
   }      
   double f01=workOma[r-1][F01+instanceNo];  double f02=workOma[r-1][F02+instanceNo];
   double f03=workOma[r-1][F03+instanceNo];  double f04=workOma[r-1][F04+instanceNo];
   double f05=workOma[r-1][F05+instanceNo];  double f06=workOma[r-1][F06+instanceNo];

   //
   //
   //
   //
   //

      if (adaptive && (averagePeriod > 1))
      {
         double minPeriod = MathMin(averagePeriod,r)/2.0;
         double maxPeriod = MathMin(minPeriod*5.0,r);
         int    endPeriod = (int)MathCeil(maxPeriod);
         double tsignal   = MathAbs((price-workOma[r-endPeriod][prc+instanceNo]));
         double noise     = 0.00000000001;

            for(int i=1; i<endPeriod && (r-i)>=0; i++) noise=noise+MathAbs(price-workOma[r-i][prc+instanceNo]);

         averagePeriod = ((tsignal/noise)*(maxPeriod-minPeriod))+minPeriod;
      }
      
      //
      //
      //
      //
      //
      
      double Kg = (2.0+constant)/(1.0+constant+averagePeriod);
      double Hg = 1.0-Kg;

      f01 = Kg * price + Hg * f01; f02 = Kg * f01 + Hg * f02; double v01 = 1.5 * f01 - 0.5 * f02;
      f03 = Kg * v01   + Hg * f03; f04 = Kg * f03 + Hg * f04; double v02 = 1.5 * f03 - 0.5 * f04;
      f05 = Kg * v02   + Hg * f05; f06 = Kg * f05 + Hg * f06; double v03 = 1.5 * f05 - 0.5 * f06;

   //
   //
   //
   //
   //

   workOma[r][F01+instanceNo] = f01;  workOma[r][F02+instanceNo] = f02;
   workOma[r][F03+instanceNo] = f03;  workOma[r][F04+instanceNo] = f04;
   workOma[r][F05+instanceNo] = f05;  workOma[r][F06+instanceNo] = f06;
   workOma[r][prc+instanceNo] = price;
   return(v03);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>Bars-2) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>Bars-3) return;
   if (first[i+1] == EMPTY_VALUE)
         if (first[i+2] == EMPTY_VALUE) 
               { first[i]  = from[i]; first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
         else  { second[i] = from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else        { first[i]  = from[i];                          second[i] = EMPTY_VALUE; }
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      string add="";
               switch (ColorChangeOn)
               {
                  case chg_onSlope: add = "slope changed to ";     break;
                  case chg_onMiddl: add = "middle level crossed "; break;
                  case chg_onInner: add = "inner level crossed ";  break;
                  case chg_onOuter: add = "outer level crossed ";  break;
               }
      static string   type1 = "";
      static datetime time1 = 0;
      if (state[whichBar] != state[whichBar+1])
      {
         if (state[whichBar] == 1) doAlert(type1,time1,add+" up");
         if (state[whichBar] ==-1) doAlert(type1,time1,add+" down");
         if (ColorChangeOn==chg_onInner || ColorChangeOn==chg_onOuter)
         {
            if (state[whichBar] !=  1 && state[whichBar+1] ==  1) doAlert(type1,time1,add+" down");
            if (state[whichBar] != -1 && state[whichBar+1] == -1) doAlert(type1,time1,add+" up");
         }            
      }         
   }
}   

//
//
//
//
//

void doAlert(string& previousAlert, datetime& previousTime, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  timeFrameToString(_Period)+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" - dynamic double zone range oma "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," dynamic double zone range oma "),message);
          if (alertsPush)    SendNotification(message);
          if (alertsSound)   PlaySound(soundfile);
   }
}